// ==UserScript==
// @name             FilterTargets [GW]
// @namespace        s3kat0r.com
// @description      Убирает из целей синдиката, все объекты, синдикаты которого не достигли нужного уровня.
// @include          http://www.ganjawars.ru/syndicate.php?id=*&page=targets*
// @version          0.1
// @author           s3kat0r
// @source           http://www.ganjawars.ru/syndicate.php?id=8516
// ==/UserScript==



(function() {
	var target = 1743;
	var level  = 10; // минимальный синдикатный уровень
	var root   = typeof unsafeWindow != 'undefined' ? unsafeWindow : window;


	var match = /http:\/\/www\.ganjawars\.ru\/syndicate\.php\?id=(\d+)&page=targets/.exec(root.location.href);

	if (match == null || match[1] != target) {
		return false;
	}

	if (typeof(root.localStorage) == 'undefined') { /*проверяем, поддерживает ли браузер объект localStorage*/
		alert('Ваш браузер не поддерживает localStorage. Скачайте Opera 10.60 или Mozilla Firefox 3.6.6 или выше версии');
		return;
	}
	var data = localStorage.getItem('s3k_SFT');
	var last = localStorage.getItem('s3k_SFT_last');

	var table  = getTopTable(); // узнаем основную таблицу. Она нужна как и при установке, так и при отображении.
	var _count = 0; //глобальная переменная, счетчик объектов, по ней идет прогресс-бар

	if (data == null || data == '' || is_update(last)) { /*данных нет, нужно обновление - собираем информацию*/
		data = new Array;
		update();
	} else {
		data = JSON.parse(data);
	}

	hideSynds();

	function update() {
		installProgressBar();
		getIgnorSynds();
		dataSave();
		root.document.getElementById('info_div').style.display = 'none';
	}

	function hideSynds() {
		for (var i = 2, length = table.rows.length; i < length; ++i) {
			var td  = table.rows[i].cells[0];
			var ret = /syndicate\.php\?id=(\d+)/i.exec(td.innerHTML);
			if (ret != null) {
				var synd_id = ret[1];
				if (in_array(synd_id, data)) {
					//alert(synd_id);
					table.rows[i].style.display = 'none';
				}
			}
		}
	}


	root.test = function () {
		_count++;
		if (_count == 10) {
			return false;
		}
		updateProgressBar();
		setTimeout('test()', 1*1000);
	}


	function getIgnorSynds() {
		for (var i = 2, length = table.rows.length; i < length; ++i) {
			var td  = table.rows[i].cells[0];
			var ret = /syndicate\.php\?id=(\d+)/i.exec(td.innerHTML);
			if (ret != null) {
				var synd_id = ret[1];
				if (in_array(synd_id, data)) {
					_count++;
					updateProgressBar();
					continue;
				}
				var xmlhttp = getXmlHttp();
				xmlhttp.open('GET', '/syndicate.php?id='+synd_id, false);
				xmlhttp.send(null);
				if (xmlhttp.status == 200) {
					var content = xmlhttp.responseText;
					var match   = /&nbsp;&nbsp;(\d+) LVL<br>/.exec(content);
					if (match != null) {
						var synd_level = match[1];
						if (synd_level < level) {
							data.push(synd_id);
						}
						_count++;
						updateProgressBar();
					}
				}
			}
		}
	}

	function dataSave() {
		localStorage.setItem('s3k_SFT', JSON.stringify(data));
		var time = new Date();
		var day  = time.getDate();
		localStorage.setItem('s3k_SFT_last', day);
	}

	function updateProgressBar() {
		var tprogress = root.document.getElementById('tprogress');
		var percent   = root.document.getElementById('percent');
		var value     = _count * 2;
		tprogress.setAttribute('width', value+'%');
		percent.innerHTML = value;
	}

	function installProgressBar() {
		var div       = document.createElement('div');
		div.align     = 'center';
		div.id        = 'info_div';
		div.innerHTML = '<table border="0" cellspacing="0" cellpadding="2"><tr><td>Обновление информации:</td><td width="50%"><table width="100%" border="1" cellpadding="0" cellspacing="0"><tr><td bgcolor="#ffffff"><table width="0%" border="0" cellpadding="0" cellspacing="0" bgcolor="#5555cc" id="tprogress" style="border-right: 1px solid #aaaaaa"><tr><td height="12"></td></tr></table></td></tr></table></td><td><font id="percent">0</font>%</td></tr></table><br />';
		table.parentNode.insertBefore(div, table);
	}



	function getTopTable() {
		var tables = root.document.getElementsByTagName('table');
		for (var i = 0, length = tables.length; i < length; ++i) {
			if (tables[i].rows[0].cells[0] != null && tables[i].rows[0].cells[0].textContent.indexOf('Топ-50 прибыльных') != -1) {
				return tables[i];
			}
		}
		return false;
	}

	function is_update(last) {
		var min_hour = 6;
		var time     = new Date();
		var day      = time.getDate();
		var hour     = time.getHours();
		if (last == null || last == '' || last == 0) {
			return true;
		}
		if (day >= 28 && hour >= min_hour && last <= 28) {
			return true;
		} else if (day >= 17 && hour >= min_hour && last <= 17) {
			return true;
		} else if (day >= 6 && hour >= min_hour && last <= 6) {
			return true;
		}
		return false;
	}

	function in_array(needle, haystack) {
		for(var key in haystack){
			if (haystack[key] == needle){
				return true;
			}
		}
		return false;
	}

	function getXmlHttp() {
		return new XMLHttpRequest();
	}



})();