﻿// ==UserScript==
// @name             NPC Info [GW]
// @namespace        s3kat0r.com
// @description      Показывает информацию о квестах NPC (доступны, находятся на стадии выполнении и если недоступны, то через сколько времени можно будет взять следующий)
// @include          http://www.ganjawars.ru/*
// @exclude          http://www.ganjawars.ru/b0/*
// @exclude          http://www.ganjawars.ru/login.php*
// @exclude          http://www.ganjawars.ru/logout.php*
// @version          2.4.2
// @author           s3kat0r
// @source           http://www.ganjawars.ru/syndicate.php?id=8516
// ==/UserScript==




(function() {


/* НАСТРОЙКИ */
var is_lite     = false; // true|false - лайт или фулл версия скрипта.
var show_attack = false; // показывает еще колонку о возможности нападения на NPC
var exclude     = [];    // Исключения.
var wait_color  = 'red';     // цвет надписи NPC, когда квесты недоступны.
var free_color  = 'green';   // цвет надписи NPC, когда квесты доступны.
var run_color   = '#998800'; // цвет надписи NPC, когда квест находится на стадии выполнения.
var bad_color   = 'blue';    // цвет надписи NPC, когда квест был завален по времени
/* НАСТРОЙКИ */



var root = typeof unsafeWindow != 'undefined' ? unsafeWindow : window;
var data = {};
var npc  = {
				'g':
				{
					'2':  {'name': 'Hempy Trown',			'icon': 'http://images.ganjawars.ru/img/synds/5867.gif'},
					'3':  {'name': 'Rusty Reefer',			'icon': 'http://images.ganjawars.ru/img/synds/5867.gif'},
					'6':  {'name': 'Donnie Ray',			'icon': 'http://images.ganjawars.ru/img/synds/5865.gif'},
					'8':  {'name': 'Ricardo Gonzalez',		'icon': 'http://images.ganjawars.ru/img/synds/5863.gif'},
					'10': {'name': 'Inamoto Kanushi',		'icon': 'http://images.ganjawars.ru/img/synds/5862.gif'},
					'12': {'name': 'John Moretti',			'icon': 'http://images.ganjawars.ru/img/synds/5866.gif'},
				},
				'z':
				{
					'1':  {'name': 'Smokie Canablez',		'icon': 'http://images.ganjawars.ru/img/synds/5867.gif'},
					'4':  {'name': 'Kenny Buzz',			'icon': 'http://images.ganjawars.ru/img/synds/5867.gif'},
					'5':  {'name':'Yoshinori Watanabe',		'icon': 'http://images.ganjawars.ru/img/synds/5862.gif'},
					'7':  {'name': 'Rony James',			'icon': 'http://images.ganjawars.ru/img/synds/5865.gif'},
					'9':  {'name': 'Tommy Morales',			'icon': 'http://images.ganjawars.ru/img/synds/5863.gif'},
					'11': {'name': 'Tony Brandino',			'icon': 'http://images.ganjawars.ru/img/synds/5866.gif'},
				},
				'p':
				{
					'16': {'name': 'Takeshi Yamagata',		'icon': 'http://images.ganjawars.ru/img/synds/5862.gif'},
					'17': {'name': 'Michael Doyle',			'icon': 'http://images.ganjawars.ru/img/synds/5865.gif'},
					'18': {'name': 'Alfonso Morales',		'icon': 'http://images.ganjawars.ru/img/synds/5863.gif'},
					'19': {'name': 'Roy Fatico',			'icon': 'http://images.ganjawars.ru/img/synds/5867.gif'},
					'20': {'name': 'Giovanni Greco',		'icon': 'http://images.ganjawars.ru/img/synds/5866.gif'},
				},
			};

var attack_style = (show_attack) ? 'font-size:11px;' : '';


/*opera fix*/
if (root.location.href.indexOf('http://www.ganjawars.ru/b0/') != -1 || location.host != 'www.ganjawars.ru') {
	return;
}

if (typeof(root.localStorage) == 'undefined') { /*проверяем, поддерживает ли браузер объект localStorage*/
	alert('Ваш браузер не поддерживает localStorage. Скачайте Opera 10.60 или Mozilla Firefox 3.6.6 или выше версии');
	return;
}

data = localStorage.getItem('s3k_npc');
if (data == null || data == '') { /*данных нет, устанавливаем скрипт*/
	install();
} else {

	if (!is_lite && root.location.href.indexOf('http://www.ganjawars.ru/me/') == -1
				 && root.location.href.indexOf('http://www.ganjawars.ru/map.move.php') == -1
				 && root.location.href.indexOf('http://www.ganjawars.ru/npc.php?id=') == -1) {
		return false;
	}

	data = eval('('+data+')');
}

var new_data = clone(data);


/*Обновляем данные, главная функция обработки всех действий пользователей*/

updateData();


/*Производим синхронизацию данных (вычисление проваленных квестов, выставление статусов смежным NPC и т.д.)*/
synchronizeData();

if (!compareObj(data, new_data)) { //новые данные отличаются от старых, поэтому их сохраняем
	dataSave();
}


/*Функции нужные для вывода данных в браузер*/

if (is_lite) {
	renderLiteData();
} else {
	renderFullData(false);
}

return;


function compareObj(obj1, obj2) {
	var json1 = JSON.stringify(obj1);
	var json2 = JSON.stringify(obj2);
	return (json1 == json2);
}

function clone(obj){
	if(obj == null || typeof(obj) != 'object')
		return obj;
	var temp = new obj.constructor(); 
	for(var key in obj)
		temp[key] = clone(obj[key]);
	return temp;
}

function in_array(needle, haystack) {
	for(var key in haystack){
		if (haystack[key] == needle){
			return true;
		}
	}
	return false;
}


function renderFullData(show) {
	if (root.location.href.indexOf('http://www.ganjawars.ru/me/') == -1) {
		return;
	}
	var npc_link = root.document.getElementById('npc_link2');
	if (npc_link == null) {
		var link  = root.document.getElementsByTagName('a');
		for (i = link.length - 1; i > 0; i--) {
			if (link[i].innerHTML == 'Друзья онлайн') {
				npc_link           = root.document.createElement('a');
				npc_link.href      = '#';
				npc_link.onclick   = function() {renderFullData(true)};
				npc_link.innerHTML = 'Квесты';
				npc_link.setAttribute('id', 'npc_link2');
				link[i].parentNode.insertBefore(npc_link, link[i]);
				npc_link.parentNode.insertBefore(document.createTextNode(' / '), npc_link.nextSibling);
				break;
			}
		}
	}
	if (show) {
		var s3c_div = root.document.getElementById('s3c_div');
		if (s3c_div == null) {
			s3c_div           = root.document.createElement('div');
			s3c_div.id        = 's3c_div';
			var table         = root.document.createElement('table');
			var island        = data['var']['island'];
			table.setAttribute('border',       '1');
			table.setAttribute('cellspacing',  '0');
			table.setAttribute('cellspadding', '0');
			var today  = new Date();
			var time   = Math.round(today.getTime() / 1000.0);
			for (npc_id in data[island]) {
				if (in_array(npc_id, exclude)) {
					continue;
				}
				var row       = table.insertRow(-1);
				var td1       = row.insertCell(-1);
				var synd_id   = /(\d+)\.gif/i.exec(npc[island][npc_id]['icon'])[1];
				td1.innerHTML = '<a href="http://www.ganjawars.ru/syndicate.php?id='+synd_id+'"><img src="'+npc[island][npc_id]['icon']+'" width="20" height="14" /></a>';
				var td2 = row.insertCell(-1);
				td2.innerHTML = '<a href="http://www.ganjawars.ru/npc.php?id='+npc_id+'" style="'+attack_style+'">'+npc[island][npc_id]['name']+'</a>';
				var td3 = row.insertCell(-1);
				td3.setAttribute('align', 'center');
				td3.innerHTML = '<b style="'+((show_attack) ? 'font-size:10px' : '')+'">'+data[island][npc_id]['status']+'</b>';
				var td4 = row.insertCell(-1);
				td4.setAttribute('align', 'center');
				if (data['var']['action'] == 'doing' || data['var']['action'] == 'get') { // квест выполняется или идет запрос пользователю
					if (npc_id == data['var']['last_npc']) {
						if (data['var']['action'] == 'get') {
							td4.innerHTML = '<b style="color:'+run_color+';'+attack_style+'">Заказ</b>';
						} else {
							var sic = TimeToMin(data[island][npc_id]['time_quest'] - (time - data[island][npc_id]['time_squest']));
							if (sic == 0) {
								td4.innerHTML = '<b style="color:'+bad_color+';'+attack_style+'">Завален</b>';
							} else {
								td4.innerHTML = '<b style="color:'+run_color+';'+attack_style+'" id="run_quest">Квест['+sic+']</b>';
							}
						}
					} else {
						td4.innerHTML = '<b style="color:'+wait_color+';'+attack_style+'">Недоступен</b>';
					}
				} else { // квесты в режиме ожидания
					if (data[island][npc_id]['time_wait'] == null) {
						td4.innerHTML = '<b>Неизвестно</b>';
					} else if (data[island][npc_id]['time_wait'] == 0) {
						td4.innerHTML = '<b style="color:'+wait_color+';'+attack_style+'">Недоступен</b>';
					} else {
						var sic = TimeToMin(data[island][npc_id]['timeout'] - (time - data[island][npc_id]['time_wait']));
						if (sic == 0) {
							td4.innerHTML = '<b style="color:'+free_color+';'+attack_style+'">Доступен</b>';
						} else {
							td4.innerHTML = '<b style="color:'+wait_color+';'+attack_style+'">Квест['+sic+']</b>';
						}
					}
				}
				if (show_attack) {
					var td5 = row.insertCell(-1);
					td5.setAttribute('align', 'center');
					if (data[island][npc_id]['time_attack'] == null || data[island][npc_id]['time_attack'] == 0) {
						td5.innerHTML = '<b style="color:'+free_color+';'+attack_style+';'+attack_style+'">Напад</b>';
					} else {
						var diff  = 20*60 - (time - data[island][npc_id]['time_attack']);
						if (diff <= 0) { // если прошло больше 20 минут с момента последнего нападения на NPC
							td5.innerHTML = '<b style="color:'+free_color+';'+attack_style+'">Напад</b>'; // данные, даже можно не обновлять в кеше
						} else {
							td5.innerHTML = '<b style="color:'+wait_color+';'+attack_style+'">Напад['+TimeToMin(diff, false)+']</b>';
						}
					}
				}
				td6 = row.insertCell(-1);
				var find_link       = root.document.createElement('a');
				find_link.href      = '#';
				find_link.id        = 'find_link';
				find_link.title     = 'Перейти в район NPC';
				find_link.innerHTML = '&raquo;&raquo;';
				find_link.onclick   = (function(id_){;return function(){LocateNPC(id_)}})(npc_id);
				td6.appendChild(find_link);
			}
			s3c_div.appendChild(table);
			var fdiv       = root.document.getElementById('friendsbody');
			fdiv.innerHTML = '';
			fdiv.appendChild(s3c_div);

			var quest = root.document.getElementById('run_quest');
			if (quest != null && data['var']['quest'] != null && data['var']['quest'] != '') {
				quest.onmouseover = function(event) {
					var div = root.document.getElementById('tooltip');
					var x   = event.pageX;
					var y   = event.pageY;
					if (div == null) {
						div = root.document.createElement('div');
						div.setAttribute('style', 'position: absolute; background: #d0eed0; width:500px');
						div.id         = 'tooltip';
						div.innerHTML  = data['var']['quest'];
						root.document.body.appendChild(div);
					}
					div.style.left    = x;
					div.style.top     = y;
					div.style.display = 'inline';
				};
				quest.onmouseout = function(event) {
					var div = root.document.getElementById('tooltip');
					if (div != null) {
						div.style.display = 'none';
					}
				};
			}
		}
	}
}



function renderLiteData() {
	var npc_link = root.document.createElement('a');
	npc_link.href = '#';
	npc_link.innerHTML = 'NPC';
	npc_link.setAttribute('id', 'npc_link');
	npc_link.setAttribute('style', 'text-decoration: none');
	var flag   = false;
	var links  = root.document.getElementsByTagName('a');
	for (var i = 0; i < links.length; i++) {
		if (links[i].innerHTML == 'Сайты') {
			links[i].parentNode.insertBefore(npc_link, links[i]);
			flag = true;
			break;
		}
	}
	if (!flag) {
		return;
	}
	npc_link.parentNode.insertBefore(root.document.createTextNode(' | '), npc_link.nextSibling);

	if (data['var']['action'] == null || data['var']['action'] == 'action') {
		return false;
	}

	var today  = new Date();
	var time   = Math.round(today.getTime() / 1000.0);
	if (data['var']['last_npc'] != null) {
		var npc_id    = data['var']['last_npc'];
		var island    = data['var']['island'];
		var npc_is    = getIslandByNpcId(data['var']['last_npc']);
		if (npc_is != island) {
			return true;
		}
		npc_link.href = 'http://www.ganjawars.ru/npc.php?id='+npc_id;

		/*делаем квест свободным/занятым если время ожидания истекло*/
		if (data['var']['action'] == 'wait' && data[island][npc_id]['time_wait'] != null && data[island][npc_id]['timeout'] != null && data[island][npc_id]['timeout'] != 0) {
			if (data[island][npc_id]['time_quest'] != null && data[island][npc_id]['time_quest'] != 0) {
				data[island][npc_id]['time_quest'] = 0;
			} else {
				var diff = data[island][npc_id]['timeout'] - (time - data[island][npc_id]['time_wait']);
				if (diff <= 0) {
					data['var']['action'] = 'free';
				}
			}
		}

		if (data['var']['action'] == 'wait') {
			npc_link.setAttribute('style', 'text-decoration: none;font-weight: bolder;color:'+wait_color);
			if (data[island][npc_id]['time_wait'] != null && data[island][npc_id]['timeout'] != null && data[island][npc_id]['timeout'] != 0) {
				npc_link.innerHTML = 'NPC ['+TimeToMin(data[island][npc_id]['timeout'] - (time - data[island][npc_id]['time_wait']))+']';
			}
		} else if (data['var']['action'] == 'free') {
			npc_link.setAttribute('style', 'text-decoration: none;font-weight: bolder;color:'+free_color);
			var find_link       = root.document.createElement('a');
			find_link.href      = '#';
			find_link.onclick   = (function(id_){return function(){LocateNPC(id_)}})(npc_id);
			find_link.title     = 'Перейти в район NPC';
			find_link.innerHTML = '&raquo;&raquo;';
			npc_link.parentNode.insertBefore(find_link, npc_link.nextSibling);
			npc_link.parentNode.insertBefore(document.createTextNode(' '), npc_link.nextSibling);


		} else if (data['var']['action'] == 'doing') {
			npc_link.setAttribute('style', 'text-decoration: none;font-weight: bolder;color:'+run_color);
			if (data[island][npc_id]['time_quest'] != null && data[island][npc_id]['time_squest'] != null) {
				var sic = data[island][npc_id]['time_quest'] - (time - data[island][npc_id]['time_squest']);
				npc_link.innerHTML = 'NPC ['+TimeToMin(sic)+']';
			}
		}
	}
}


function install() {
	showMessage();

	data        = {};
	data['var'] = {};

	/*Получаем информацию об острове нахождения персонажа*/
	if (root.location.href.indexOf('http://www.ganjawars.ru/me') != -1) {
		var link = root.document.body.getElementsByTagName('a');
		for (i = 0; i < link.length; ++i) {
			if (link[i].href != null && /map\.php\?sx=\d+&sy=\d+/i.test(link[i].href)) {
				if (match = /\[(g|z|p|s)\]\s.*/i.exec(link[i].textContent)) {
					data['var']['island'] = match[1].toLowerCase();
					break;
				}
			}
		}
	} else {
		var xmlhttp = getXmlHttp();
		xmlhttp.open('GET', '/me/', false);
		xmlhttp.send(null);
		if (xmlhttp.status == 200) {
			var content = xmlhttp.responseText;
			if (match = /map\.php\?sx=\d+&sy=\d+[^>]+>\[(g|z|p|s)\]\s.*/i.exec(content)) {
				data['var']['island'] = match[1].toLowerCase();
			}
		}
	}
	if (data['var']['island'] == null) {
		alert('Возникла ошибка определения острова. Если вы на ауте, прилетите обратно на остров.');
		hideMessage();
		return false;
	}

	/*Остров определили, теперь определяем инфу по NPC*/
	if (npc[data['var']['island']] == null) { // нет NPC в этой карте.
		hideMessage();
		return false;
	}
	for (is in npc) {
		data[is]    = {};
		for (id in npc[is]) {
			var xmlhttp = getXmlHttp();
			xmlhttp.open('GET', '/npc.php?id='+id, false);
			xmlhttp.send(null);
			if (xmlhttp.status == 200) {
				var span       = document.createElement('span');
				span.innerHTML = xmlhttp.responseText;
				/*нам нужно знать только статусы*/
				var table     = span.getElementsByTagName('table');
				for (var i = table.length - 1; i > 0; i--) {
					if (table[i].rows[0] == null || table[i].rows[0].cells[0] == null) {
						continue;
					}
					if (table[i].rows[0].cells[0].textContent.indexOf('Ваш статус') != -1) {
						data[is][id] = {};
						data[is][id]['status']  = table[i].rows[0].cells[1].textContent;
						data[is][id]['timeout'] = getTimeout(data[is][id]['status']);
						break;
					}
				}
				span = null; /*очищаем тяжелый объект*/
			}
		}
	}
	dataSave();
	hideMessage();
	alert('Установка завершена, приятного вам использования =) ');
}



function getXmlHttp() {
	return new XMLHttpRequest();
}



function showMessage() { 
	var height = root.window.innerHeight;
	var width  = root.window.innerWidth;
	var hdiv   = document.createElement('div');
	hdiv.id    = 'hdiv';
	hdiv.setAttribute('style', 'display: none; position: absolute; background: #000000; opacity: 0.7; width: 100%; height: 100%; top: 0; left: 0; z-index: 99;');
	root.document.body.appendChild(hdiv);

	var mdiv       = document.createElement('div');
	mdiv.id        = 'mdiv';
	mdiv.innerHTML = '<table class="sexyX"><tr><td align="center" style="background: #635274;">Идет установка скрипта NPC INFO от s3kat0r</td></tr><td>Не делайте пожалуйста резких движений и не трогайте браузер.<br />Если будете себя хорошо вести, установка закончится секунд за 20.</td></tr><tr><td align="center"><img src="http://f.ganjafile.ru/8/83138_install.gif" /></td></tr></table>';
	mdiv.setAttribute('style', 'display: none; position: absolute; background: #b9e77b; color: #333; font-size: 12px; text-align: center; border: 1px solid #111; z-index: 100;');
	root.document.body.appendChild(mdiv);

	hdiv.style.display = 'block';
	mdiv.style.display = 'block';
	mdiv.style.left    = Math.round((width - mdiv.offsetWidth) / 2)+'px';
	mdiv.style.top     = Math.round(height / 2)+'px';
}




function hideMessage() {
	root.document.getElementById('hdiv').style.display = 'none';
	root.document.getElementById('mdiv').style.display = 'none';
}




function updateData() {

	if (root.location.href.indexOf('http://www.ganjawars.ru/map.move.php') != -1) { /*персонаж перемещается ,а вдруг негодяй покинул остров? С любовью, ваш Джон Лок.*/
		var center = root.document.getElementById('mmdiv').parentNode;
		if (center == null) {
			return;
		}
		if (match = /в\s\[(g|z|p|s)\]\s.*?\./i.exec(center.textContent)) {
			var isi = match[1].toLowerCase();
			if (isi != data['var']['island']) {
				data['var']['island'] = isi;
			}
		}
	}

	var action = '';
	var island = data['var']['island'];
	if (root.location.href.indexOf('http://www.ganjawars.ru/npc.php?id=') != -1) {
		var npc_id = /id=(\d+)/i.exec(root.location.href)[1];
		if (npc_id == null) {
			npc_id = 0;
		}
		if (root.location.href.indexOf('talk=1') != -1) {
			action = 'talk';
		}
		if (root.location.href.indexOf('action_submit=yes') != -1) {
			action = 'take';
		}
		if (root.location.href.indexOf('action_submit=no') != -1) {
			action = 'drop';
		}
		var table     = root.document.getElementsByTagName('table');
		var content   = '';
		var answer    = '';
		var status    = '';
		for (var i = table.length - 1; i > 0; i--) {
			if (table[i].rows[0] == null || table[i].rows[0].cells[0] == null) {
				continue;
			}
			if (table[i].rows[0].cells[0].textContent.indexOf('Ваш статус') != -1) {
				status = table[i].rows[0].cells[1].textContent;
			}
			if (table[i].rows[0].cells[0].textContent.indexOf('Связь с персонажем') != -1) {

				var npc_table     = table[i].getElementsByTagName('table');
				if (npc_table[0] == null) {
					content = table[i].rows[1].cells[0].innerHTML;
				} else {
					content = npc_table[0].rows[0].cells[1].innerHTML;
					answer  = npc_table[0].rows[1].cells[1].innerHTML;
				}
			}
			if (status != '' && content != '') {
				break;
			}
		}
		if (npc_id == 0) {
			return false;
		}

		status                          = parseFloat(status);
		data[island][npc_id]['status']  = status;
		data[island][npc_id]['timeout'] = getTimeout(data[island][npc_id]['status']);
		var today                       = new Date();

		/*ставим ссылку*/

		if (content.indexOf('Вы находитесь в другом секторе') != -1) {
			var link     = root.document.getElementsByTagName('a');
			var go_link  = root.document.createElement('a');
			go_link.innerHTML = '[&raquo;&raquo;]';
			go_link.title     = 'Перейти на район синдиката';
			for (var i = 0; i < link.length; i++) {
				if (/map\.php\?sx=(\d+)&sy=(\d+)/i.test(link[i].href)) {
					var match    = /map\.php\?sx=(\d+)&sy=(\d+)/i.exec(link[i].href);
					go_link.href = 'map.move.php?sxy='+match[1]+'x'+match[2]+'&gps=1';
					link[i].appendChild(document.createTextNode(' '));
					link[i].appendChild(go_link);
					break;
				}
			}
		}

		/*вешаем свой обработчик ссылки для нападения*/
		var link     = root.document.getElementsByTagName('a');
		for (var i = link.length - 1; i > 0; i--) {
			if (link[i].href.indexOf('attack=1') != -1) {
				link[i].onclick = function() {
					data[island][npc_id]['time_attack'] = Math.round(today.getTime() / 1000.0);
					dataSave();
					if (confirm('Вы действительно хотите напасть?')) {
						return true;
					} else {
						return false;
					}
				};
			}
		}

		if (action == 'talk') {
			data[island][npc_id]['status']  = status;
			data[island][npc_id]['timeout'] = getTimeout(status);
			if (content.indexOf('Вы находитесь в другом секторе') != -1) {
				/*
				* ничего не делаем, нам неизвестно ничего
				*/
			} else if (content.indexOf('Я сейчас занят') != -1) {
				data['var']['action']               = 'wait';
				data[island][npc_id]['time_squest'] = 0;
				data[island][npc_id]['s_status']    = 0;
				var time = Math.round(today.getTime() / 1000.0);
				if (data[island][npc_id]['time_wait'] != null && data[island][npc_id]['timeout'] != null && data[island][npc_id]['time_wait'] != 0) {
					var diff = data[island][npc_id]['timeout'] - (time - data[island][npc_id]['time_wait']);
					if (diff <= 0) {
						data[island][npc_id]['time_wait'] = 0;
					}
				}
			} else if (content.indexOf('Задание не выполнено') != -1) {
				data['var']['last_npc']  = npc_id;
				data['var']['action']    = 'doing';
				if (data[island][npc_id]['time_squest'] == null || data[island][npc_id]['time_squest'] == 0) {
					if (match = /Квест должен быть выполнен до (\d+)\.(\d+)\.(\d+) (\d+):(\d+)/i.exec(content)) {
						var humDate = new Date(Date.UTC('20'+match[3], match[2], match[1], match[4], match[5]));
						var msec    = Math.round(humDate.getTime() / 1000.0);
						var current = Math.round(today.getTime()   / 1000.0);
						data[island][npc_id]['time_quest']  = msec;
						data[island][npc_id]['time_squest'] = current - msec;
					}
				}
			} else if (answer.indexOf('action_submit=') != -1) { /*получаем задание, изначально загадывая что юзер его примет*/
				data['var']['action']    = 'get';
				data['var']['last_npc']  = npc_id;
				data['var']['quest']     = content;
				if (match = /(<b>)?(\d+)(<\/b>)? минут/i.exec(content)) {
					min   = parseInt(match[2]);
					data[island][npc_id]['time_quest'] = min * 60;
				} else {
					alert('Возникла ошибка, сообщите разработчику');
					return;
				}
			} else { // игрок закончил квест
				data['fetch']                           = 'update';
				data['var']['quest']                    = '';
				data['var']['action']                   = 'wait';
				data['var']['last_npc']                 = npc_id;
				data['var']['last_time']                = Math.round(today.getTime() / 1000.0);
				data[island][npc_id]['time_wait']       = Math.round(today.getTime() / 1000.0);
				data[island][npc_id]['time_squest']     = 0;
				data[island][npc_id]['time_quest']      = 0;
				data[island][npc_id]['status']          = status;
				if (data[island][npc_id]['status'] == data[island][npc_id]['s_status']) { /*завалил квест*/
					data[island][npc_id]['status'] -= 0.04;
				}
				data[island][npc_id]['s_status']        = 0;
			}
		}

		if (action == 'take') {
			data['fetch']                       = 'update';
			data[island][npc_id]['time_squest'] = Math.round(today.getTime() / 1000.0);
			data['var']['action']               = 'doing';
			data[island][npc_id]['status']      = status;
			data[island][npc_id]['s_status']    = data[island][npc_id]['status'];
			data['var']['last_npc']             = npc_id;
		}

		if (action == 'drop') {
			data['fetch']                           = 'update';
			data['var']['quest']                    = '';
			data['var']['action']                   = 'wait';
			data['var']['last_npc']                 = npc_id;
			data['var']['last_time']                = Math.round(today.getTime() / 1000.0);
			data[island][npc_id]['time_wait']       = Math.round(today.getTime() / 1000.0);
			data[island][npc_id]['time_squest']     = 0;
			data[island][npc_id]['time_quest']      = 0;
			data[island][npc_id]['s_status']        = 0;
		}
	}
}


function dataSave() {
	localStorage.setItem('s3k_npc', JSON.stringify(data));
}


function getIslandByNpcId(id) {
	for (island in npc) {
		for (npc_id in npc[island]) {
			if (npc_id == id) {
				return island;
			}
		}
	}
	return null;
}


function getNPCidByName(name) {
	for (island in npc) {
		for (npc_id in npc[island]) {
			if (npc[island][npc_id]['name'] == name) {
				return npc_id;
			}
		}
	}
	return null;
}

function synchronizeData() {
	if (data['fetch'] != null) { // апдейт и другие события
		if (data['fetch'] == 'update') { // взятие ,выполнение или завершение квеста. обновляем таймер у всех.
			for (island in npc) {
				for (npc_id in npc[island]) {
					if (data[island][npc_id]['timeout'] == null) {
						data[island][npc_id]['timeout'] = getTimeout(data[island][npc_id]['status']);
					}
					if (npc_id == data['var']['last_npc']) {
						continue;
					}
					data[island][npc_id]['time_wait'] = data['var']['last_time'];
				}
			}
		}
		delete(data['fetch']);
	}
}





function LocateNPC (npc_id) {
	var xmlhttp = getXmlHttp();
	xmlhttp.onreadystatechange = function() {
		if (xmlhttp.readyState == 4) {
			if (xmlhttp.status == 200) {
				var content = xmlhttp.responseText;
				if (content.indexOf('Вы находитесь в одном секторе') != -1) {
					root.location.href = 'http://www.ganjawars.ru/npc.php?id='+npc_id;
				} else {
					var match   = /map\.php\?sx=(\d+)&sy=(\d+)/i.exec(content);
					if (match != null) {
						root.location.href = 'http://www.ganjawars.ru/map.move.php?sxy='+match[1]+'x'+match[2]+'&gps=1';
					}
				}
			}
		}
	}
	xmlhttp.open('GET', '/npc.php?id='+npc_id, true);
	xmlhttp.send(null);
}



function getTimeout(rating) {
	rating   = parseFloat(rating);
	var res  = 14400 - rating * 100 * 144;
	if (res < 7200) {
		res = 7200;
	}
	return res;
}

function TimeToMin(timeleft, showHour) {
	if (timeleft <= 0) {
		return '0';
	}
	if (showHour == null) {
		showHour = true;
	}
	var string = '';
	var time   = timeleft;
	var hour = Math.floor(time / 3600);
	if (hour < 10) {
		hour = '0'+hour;
	}
	if (showHour) {
		string += hour + ':';
	}
	time   -= hour * 3600;
	var min = Math.floor(time / 60);
	if (min < 10) {
		min = '0'+min;
	}
	string += min + ':';
	time   -= min * 60;
	var sec = time;
	if (sec < 10) {
		sec = '0'+sec;
	}
	string += sec;
	return string;
}

})();


